; Simulador del TMS320C3x v2.1 - Proyecto de Fin de Carrera
; Ingenieria Tecnica de Telecomunicacin
; Rubn Alonso Alejandre - Joaqun Cubillo Arribas

; Ejemplo 2.- Copia una tabla de datos enteros de 32bits de una
;             zona de memoria a otra posicin.

;*** CODIGO ***************************************************************************
                .start  "CODIGO", 0x809802      ;Comienzo de la seccion de programa
                .sect   "CODIGO"
                .entry  PRACT21                 ;Punto de entrada

PRACT21         LDP     @DATOS                  ;Inicializa el registro DP
                LDI     @stack, SP              ;Inicializa el puntero de pila

                LDI     @pvtabla1, AR0          ;AR0 apunta a la tabla 1 (origen)
                LDI     @pvtabla2, AR1          ;AR1 apunta a la tabla 2 (destino)
                LDI     N-1, RC                 ;Numero de iteraciones
                RPTB    FINBUCLE                ;Repite hasta FINBUCLE N-1 veces
                LDI     *AR0++, R0              ;Carga lo apuntado por AR0 en R0
FINBUCLE        STI     R0, *AR1++              ;Carga R0 en la posicion apuntada por AR1


;*** DATOS **************************************************************************
                .start "DATOS", 0x809C00        ;Comienzo de la seccion de datos
                .sect  "DATOS"
                .word  1,2,3,4,5,6,7,8,9,10     ;Tabla inicial
                .space 10                       ;Espacio reservado para la tabla final
N               .set   10                       ;longitud de la tabla
pvtabla1        .word DATOS                     ;puntero a la tabla inicial
pvtabla2        .word DATOS+N                   ;puntero a la tabla final

; Espacio de memoria para la pila
stack           .word $+1                       ;comienzo de la pila
                .space 256                      ;reservamos 256 posiciones
                .end