; Simulador del TMS320C3x v2.1 - Proyecto de Fin de Carrera
; Ingenieria Tecnica de Telecomunicacin
; Rubn Alonso Alejandre - Joaqun Cubillo Arribas

; Ejemplo 5.- Conversion IEEE -> FLOAT TMS
;

;*** CODIGO ***************************************************************************

        .start "CODIGO",0x809802        ;Comienzo de la seccion de programa
        .sect "CODIGO"
        .entry PRUEBA                   ;Punto de entrada
;--------------------------------------------------------------------------
PRUEBA  LDP @stack                      ;Inicializar registro DP
        LDI @stack,SP                   ;Inicializar puntero de pila
        ;------------------------------------------------------------------

         LDI @IEEE,AR0
         LDI @TMS, AR3
         LDI N-1, RC

         RPTB FINBUCLE
         LDI *AR0++,R0
         CALL Rutina
FINBUCLE STI R0,*AR3++
         IDLE

Rutina  PUSH AR1                        ;Salvamos el la pila los registros utilizados
        PUSH AR2
        PUSH R1
        PUSH R2
        PUSH R3

        LDI @P_MASC,AR1                 ;AR1 = PUNTERO A LAS MASCARAS
        LDI @P_EXCEP,AR2                ;AR2 = Puntero a los casos excepcionales
        LDI R0,R1                       ;copia de reserva de R0 en R1
        LDI *+AR1(1),R2                 ;R2=Mascara de exponente
        AND R2,R0                       ;tomamos exponente
        CMPI 0,R0                       ;si el exponente es cero ...
        BEQ CERO_DESN                   ;...el nmero es cero o desnormalizado
        CMPI *+AR1(1),R0                ;si el exponenente no es 255...
        BNE NORMAL                      ;...el nmero es normal

INF_NaN                                 ;tratamos inf y NaN
        LDI *+AR1(2),R2                 ;R2=Mascara de mantisa
        AND R2,R1                       ;R1=Mantisa
        CMPI 0,R1                       ;Mantisa=0?
        BNE NaN
INF                                     ;si, infinito
        LDI *AR2,R0                     ;devolvemos maximo valor de TMS
        BR FINRUT
NaN                                     ;no, NaN
        LDI *+AR2(1),R0                 ;devolvemos todo 1's indicando error
        BR FINRUT

CERO_DESN                               ;tratamos cero y desnormalizado
        LDI *+AR1(2),R2                 ;R2=Mascara de mantisa
        AND R2,R1                       ;R1=Mantisa
        CMPI 0,R1                       ;Mantisa=0?
        BNE DESN
CERO                                    ;si, cero
        LDI *+AR2(2),R0                 ;devolvemos valor de cero
        BR FINRUT
DESN                                    ;no, desnormalizado
        LDI *+AR2(1),R0                 ;devolvemos todo 1's indicando error
        BR FINRUT

NORMAL
        LDI R0,R3                       ;exponente en R3
        LSH -23,R3                      ;exponente a la parte baja
        ADDI -127,R3			    ;valor real del exponente
        LSH 24,R3                       ;R3=exponente a su sitio en TMS
        LDI R1,R0
        LDI R1,R2
        AND *+AR1(2),R0                 ;R0=mantisa
        AND *AR1,R2                     ;R2=bit de signo
        CMPI *AR1,R2                     ;si (-) se hace C2 de mantisa
        BNE POS1                        ;sino el numero es (+)
        OR *AR1,R0                      ;mantisa en C2. Extension de su signo
        OR *+AR1(1),R0                  ;sigue la extension de su signo
        NEGI R0,R0                      ;C2 de mantisa
POS1
        LSH -8,R2                       ;signo a su sitio en TMS
        OR R2,R0                        ;juntamos los trozos
        OR R3,R0
FINRUT
        POP R3                          ;Recuperamos el valor de los registros
        POP R2
        POP R1
        POP AR2
        POP AR1

        RETSU

;--------------------------------------------------------------------------
        .start "DATOS",0x809C00          ;Comienzo de la seccion de datos
        .sect "DATOS"
MASC    .word 80000000h                  ;mascaras para formato IEEE (signo)
        .word 7F800000h                  ;(exponente)
        .word 007FFFFFh                  ;(mantisa)
TABLA   .ieee 9999e100
        .ieee 3.5e38
        .ieee 3.402e38
        .ieee 2.5
        .ieee 5.32e-36
        .ieee 5.86e-39
        .ieee 0
        .ieee -5.86e-39
        .ieee -5.32e-36
        .ieee -2.5
        .ieee -3.402e38
        .ieee -3.5e38
        .word 0000000Fh                 ;Numero desnormalizado (mant !=0, exp = 0)
N       .set  13
RESULT  .space N
        .float 9999e100
        .float 3.5e38
        .float 3.402e38
        .float 2.5
        .float 5.32e-36
        .float 5.86e-39
        .float 0
        .float -5.86e-39
        .float -5.32e-36
        .float -2.5
        .float -3.402e38
        .float -3.5e38

EXCEP   .word 7F7FFFFFh                  ;infinito en TMS
        .word 0FFFFFFFFh                 ;todo 1's para indicar error en TMS
        .word 80000000h                  ;cero en TMS
P_MASC  .word MASC                      ;Puntero a las mascaras
P_EXCEP .word EXCEP                     ;Puntero a EXCEP
IEEE    .word TABLA                 ;puntero a los datos
TMS     .word RESULT                ;puntero a los resultados

        ;------------------------------------------------------------------
stack   .word $/+1                      ;comienzo de la pila
        .space 256                      ;reservamos 256 posiciones

        .end