; Simulador del TMS320C3x v2.1 - Proyecto de Fin de Carrera
; Ingenieria Tecnica de Telecomunicacin
; Rubn Alonso Alejandre - Joaqun Cubillo Arribas

; Ejemplo 6.- CALCULO DEL INVERSO DE LA RAIZ CUADRADA DE UN N


        .start "CODIGO",0x809802
        .sect  "CODIGO"
        .entry INICIO

INICIO  LDP @stack
        LDI @stack,SP
        LDI @P_DATOS, AR0            ;Cargamos dato en R0
        LDI @P_RAIZ, AR1
        LDI N, R2              ;

BUCLE    LDF *AR0, R0
         CALL RUTINA             ;Saltamos a Rutina
         LDF *AR0++, R1          ;Cargamos dato en R1
         MPYF R1,R0              ;Multiplicamos por el inverso
         STF R0,*AR1++           ;Pasamos resultado a memoria
         SUBI 1, R2
         CMPI 0, R2
         BHI BUCLE

        IDLE

RUTINA  PUSH R1
        PUSH R2
        PUSH R6
        PUSH RC

        LDF 1.5,R6              ;Cargamos cte en R6
        LDE R0,R1               ;Pasamos el exponente a R1
        PUSHF R1
        POP R1                  ;Quitamos los 8 bits menos significativos
        LSH -25,R1              ;Llevamos a la parte baja y dividimos por 2
        NEGI R1,R1              ;Hacemos el complemento
        LSH 24,R1               ;Desplazamos a parte alta
        PUSH R1
        POPF R1
        MPYF 0.5,R0             ;Dividimos por 2
        LDI CONTAD,RC           ;Cargamos nmero de iteraciones (N-1)

        RPTB F_BUCLE
        MPYF3 R1,R1,R2          ;R2=X[i-1]*X[i-1]
        MPYF R0,R2              ;R2=R2*v/2
        SUBF3 R2,R6,R2          ;R2=1.5-R2
F_BUCLE MPYF R2,R1              ;R1=X[i-1]*R2

        LDF R1,R0               ;Cargamos resultado en R0

        POP RC
        POP R6                  ;Cargamos los valores anteriores de los registros.
        POP R2
        POP R1


        RETSU                   ;Retorno de subrutina


;-------------- SECCION DE DATOS----------------------

        .start "DATOS",0X809C00
        .sect "DATOS"
TABLA   .float 16.0
        .float 2.0
N       .set   2
RAIZ    .space N
CONTAD  .set 4
P_DATOS .word TABLA
P_RAIZ  .word RAIZ
stack   .word $+1
        .space 256
        .end